﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhoenixUpdate.Class;

namespace PhoenixCommander.GUI
{
    public partial class fr_Update : Form
    {
        #region Variables
        XmlUpdateManager vXmlUpdateManager;
        #endregion

        #region Constructors
        /// <summary>
        /// Constructor
        /// </summary>
        public fr_Update()
        {
            InitializeComponent();
        }
        #endregion

        #region Properties
        /// <summary>
        /// Gets or sets the informations about the update
        /// </summary>
        public XmlUpdateManager XmlUpdateManager
        {
            get { return vXmlUpdateManager; }
            set { vXmlUpdateManager = value; }
        }
        #endregion

        #region Events
        /// <summary>
        /// The frame is loading
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Frame_Load(object sender, EventArgs e)
        {
            lbl_Info.Text = "Phoenix Suite " + vXmlUpdateManager.VersionTitle;
            lbl_Date.Text = "Disponible depuis " + vXmlUpdateManager.Date.ToShortDateString();
            tb_Info.Text = vXmlUpdateManager.Text;
        }
        /// <summary>
        /// Clock on YES
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_Yes(object sender, EventArgs e)
        {
            base.DialogResult = DialogResult.Yes;
            this.Close();
        }
        /// <summary>
        /// Click on NO
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_No(object sender, EventArgs e)
        {
            base.DialogResult = DialogResult.No;
            this.Close();
        }
        #endregion

        #region Methods
        /// <summary>
        /// Unactivate the closing cross
        /// </summary>
        protected override CreateParams CreateParams
        {
            get
            {
                CreateParams cp = base.CreateParams;
                cp.ClassStyle |= 0x0200;
                return cp;
            }
        }
        #endregion

    }
}
