using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization;
using System.IO;

namespace Utils.Misc
{
    /// <summary>
    /// Classe pour la srialisation et la dsrialisation
    /// </summary>
    [Serializable]
    public class Serializer
    {
        #region Variables
        /// <summary>
        /// Path of the serialized file
        /// </summary>
        protected string vPath = ApplicationPath.CommandPath + "\\" + DateTime.Now.Ticks + ".srz";
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructor
        /// </summary>
        public Serializer() { }
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="_Path">Donne le path du du fichier dans lequel on srialise</param>
        public Serializer(string _Path) { vPath = _Path; }
        #endregion

        #region Mthodes
        /// <summary>
        /// Serialize the object indicated in 
        /// _FilePath
        /// </summary>
        /// <param name="_FilePath">Path within the serialization will save</param>
        /// <param name="_ToSerialize">Object to serialize</param>
        /// <exception cref="SerializationException">Pour une erreur dans la srialisation ou la dsrialisation</exception>
        /// <exception cref="ArgumentNullException">Le FileStream pour la dsrialisation </exception>
        public static void Serialize(object _ToSerialize, string _FilePath)
        {
            try
            {
                BinaryFormatter bf = new BinaryFormatter();
                FileStream fs = new FileStream(_FilePath, FileMode.Create, FileAccess.Write);
                bf.Serialize(fs, _ToSerialize);
                fs.Close();
            }
            catch (SerializationException) { throw; }
            catch (ArgumentNullException) { throw; }
            catch (Exception) { throw; }
        }
        /// <summary>
        /// Serialize the object
        /// </summary>
        /// <param name="_ToSerialize">Object to serialize</param>
        /// <exception cref="SerializationException">Pour une erreur dans la srialisation ou la dsrialisation</exception>
        /// <exception cref="ArgumentNullException">Le FileStream pour la dsrialisation </exception>
        public void Serialize(object _ToSerialize)
        {
            try
            {
                Serialize(_ToSerialize, vPath);
            }
            catch (SerializationException) { throw; }
            catch (ArgumentNullException) { throw; }
        }
        /// <summary>
        /// Deserialize the file indacated with _FilePath
        /// </summary>
        /// <param name="_FilePath">Path of the file to deserialize</param>
        /// <returns>Deserialized object</returns>
        /// <exception cref="SerializationException">Pour une erreur dans la srialisation ou la dsrialisation</exception>
        /// <exception cref="ArgumentNullException">Le FileStream pour la dsrialisation </exception>
        /// <exception cref="ArgumentNullException">Le fichier  srialiser n'est pas trouv</exception>
        public static object Deserialize(string _FilePath)
        {
            try
            {
                BinaryFormatter bf = new BinaryFormatter();
                FileStream fs = new FileStream(_FilePath, FileMode.Open, FileAccess.Read);
                object ret = bf.Deserialize(fs);
                fs.Close();
                return ret;

            }
            catch (FileNotFoundException) { throw; }
            catch (SerializationException) { throw; }
            catch (ArgumentNullException) { throw; }
            catch (ArgumentException) { throw; }
        }
        /// <summary>
        /// Deserialize the file
        /// </summary>
        /// <returns>L'objet dsrialis</returns>
        /// <exception cref="SerializationException">Pour une erreur dans la srialisation ou la dsrialisation</exception>
        /// <exception cref="ArgumentNullException">Le FileStream pour la dsrialisation </exception>
        public object Deserialize()
        {
            try { return Deserialize(vPath); }
            catch (SerializationException) { throw; }
            catch (ArgumentNullException) { throw; }
        }
        #endregion
    }
}
