using System;
using System.Collections.Generic;
using System.Text;
using System.Globalization;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization;
using System.Net.Mail;
using System.Net;

namespace Utils.Misc
{
    /// <summary>
    /// Strings manager
    /// </summary>
    public class TextManager
    {
        /// <summary>
        /// Replace the accents with the same letters without accent
        /// </summary>
        /// <param name="_value">Text to modify</param>
        /// <returns>The text without accent</returns>
        public static string RemoveAccent(string _value)
        {
            _value = _value.Replace("", "e");
            _value = _value.Replace("", "e");
            _value = _value.Replace("", "e");
            _value = _value.Replace("", "e");

            _value = _value.Replace("", "u");
            _value = _value.Replace("", "u");

            _value = _value.Replace("", "o");
            _value = _value.Replace("", "o");

            _value = _value.Replace("", "y");

            _value = _value.Replace("", "a");
            _value = _value.Replace("", "a");
            _value = _value.Replace("", "a");

            _value = _value.Replace("", "i");
            _value = _value.Replace("", "i");

            _value = _value.Replace("", "c");
            _value = _value.Replace("", "n");

            return _value;
        }

        /// <summary>
        /// Replace the accents with the same letters without accent
        /// </summary>
        /// <param name="_value">Text to modify</param>
        /// <param name="_IsCapital">If TRUE returns the text in capital otherwise no.</param>
        /// <returns>The text without accent</returns>
        public static string RemoveAccent(string _value, bool _IsCapital)
        {
            if (_IsCapital)
                return RemoveAccent(_value).ToUpper();
            else
                return RemoveAccent(_value).ToLower();
        }

        /// <summary>
        /// Sets the first caracter in capital
        /// </summary>
        /// <param name="_value">Le texte dont le premier lettre doit tre en majuscule</param>
        /// <returns>The text with the first caracter in capital</returns>
        public static string FirstUpper(string _value)
        {
            string temp = _value.Substring(0, 1);
            return temp.ToUpper() + _value.Remove(0, 1);
        }

        /// <summary>
        /// Count the sub string in the string
        /// </summary>
        /// <param name="_Value">String in which the _SubString will be counted</param>
        /// <param name="_SubValue">substring that will be counted in the string</param>
        /// <returns>The number of sub string in the string</returns>
        public static int CountIn(string _Value, string[] _SubValue)
        {
            if (_Value == null || _SubValue == null) return 0;
            string[] buf = _Value.Split(_SubValue, StringSplitOptions.None);
            return buf.Length;
        }
    }
}
